/*
 * Created on 26 sept. 2005
 *
 */
package net.sf.emis.ide.editors;

import org.eclipse.core.resources.IFile;
import org.eclipse.pde.internal.ui.editor.JarEntryEditorInput;
import org.eclipse.pde.internal.ui.editor.SystemFileEditorInput;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorMatchingStrategy;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.ide.ResourceUtil;


/**
 * inspir de ManifestEditorMatchingStrategy
 *
 */
public class AliasSetEditorMatchingStrategy implements IEditorMatchingStrategy {

    public boolean matches(IEditorReference editorRef, IEditorInput input) {
        System.out.println("AliasSetEditorMatchingStrategy.matches() called");
        IFile inputFile = ResourceUtil.getFile(input);
        if (inputFile != null && input instanceof IFileEditorInput) {
            String path = inputFile.getProjectRelativePath().toString();
            System.out.println(path);
            if (path.endsWith("emis-alias-set.xml") || path.endsWith("emis-alias-set.properties")) { 
                try {
                    IFile editorFile = ResourceUtil.getFile(editorRef.getEditorInput());
                    return editorFile != null && inputFile.getProject().equals(editorFile.getProject());
                } catch (PartInitException e) {
                    return false;
                }
            }
        } else if (input instanceof SystemFileEditorInput || input instanceof JarEntryEditorInput) {
            try {
                IEditorInput existing = editorRef.getEditorInput();
                return input.equals(existing);
            } catch (PartInitException e1) {
            }       
        }
        return false;
    }

}
