/*
 * Created on 26 sept. 2005
 *
 */
package net.sf.emis.ide.wizards;

import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.SubProgressMonitor;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.osgi.util.NLS;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.actions.WorkspaceModifyOperation;
import org.eclipse.ui.dialogs.ContainerGenerator;
import org.eclipse.ui.internal.ide.IDEWorkbenchMessages;
import org.eclipse.ui.internal.ide.IDEWorkbenchPlugin;


public class NewAliasSetPrefsPage extends AbstractSetPrefsPage {

    public static String ID = "NewAliasSetPrefsPage";
    
    //private HashMap varMap = new HashMap();
    
    public NewAliasSetPrefsPage(String pageName) {
        super(ID, pageName, "Les paramtre FTp permettent le dploiement des ressources. Les paramtre de comptes eMail sont ceux utiliss pour configurer la ressource.");
     }

    public void createControl(Composite parent) {

        initializeDialogUnits(parent);
        // top level group
        Composite composite = new Composite(parent, SWT.NONE);
        composite.setFont(parent.getFont());
        composite.setLayout(new GridLayout());
        composite.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_FILL
                | GridData.HORIZONTAL_ALIGN_FILL));
        
        Group group = createGroup(composite, "Set", 2);
        createTextField(group, "set.name", "Set Name : ");
        group = createGroup(composite, "Paramtres FTP", 2);
        createTextField(group, "ftp.host", "Ftp Host : ");
        createTextField(group, "ftp.port", "Ftp Port : ");
        createTextField(group, "ftp.dir", "Ftp Dir : ");
        createTextField(group, "ftp.user", "Ftp User : ");
        createTextField(group, "ftp.pwd", "Ftp Password : ");
        createTextField(group, "ftp.passive", "Ftp Mode Passive (yes|no) : ");
        group = createGroup(composite, "Compte eMail", 2);
        createTextField(group, "alias.name", "Alias name : ");
        createTextField(group, "alias.user", "Alias username : ");
        createTextField(group, "alias.pwd", "Alias password: ");
        createTextField(group, "alias.pop3", "POP3 host : ");
        createTextField(group, "alias.smtp", "SMTP host : ");
        createTextField(group, "alias.from", "Alias from : ");
        
        setControl(composite);
        setPageComplete(false);
        
        
    }
    

    
    public void createFileSet(final IFolder folder) {
        
        WorkspaceModifyOperation op = new WorkspaceModifyOperation(createRule(folder)) {
            public void execute(IProgressMonitor monitor) throws CoreException {
                try {
                    monitor.beginTask(IDEWorkbenchMessages.WizardNewFolderCreationPage_progress, 2000);
                    ContainerGenerator generator = new ContainerGenerator(folder.getFullPath());
                    generator.generateContainer(new SubProgressMonitor(monitor, 1000));
                    
                    InputStream is = getResourceStream("templates/alias-set-build.xml");
                    IFile buildHandle = createFileHandle(folder.getFullPath().append("build.xml"));
                    createFile(buildHandle, is, new SubProgressMonitor(monitor, 400));

                    is = getResourceStream("templates/emis-alias-set.properties");
                    IFile propertiesHandle = createFileHandle(folder.getFullPath().append(".emis-alias-set.properties"));
                    createFile(propertiesHandle, is, new SubProgressMonitor(monitor, 300));
                    replaceContent(propertiesHandle);
                    
                    is = getResourceStream("templates/emis-alias-set.xml");
                    IFile aliasHandle = createFileHandle(folder.getFullPath().append(".emis-alias-set.xml"));
                    createFile(aliasHandle, is, new SubProgressMonitor(monitor, 300));
                    replaceContent(aliasHandle);
                    
                    folder.refreshLocal(IResource.DEPTH_ONE, null);
                    
                } catch (Throwable th) {
                    th.printStackTrace();
                } finally {
                    monitor.done();
                }
            }
        };

        try {
            getContainer().run(true, true, op);
        } catch (InterruptedException e) {
            return;
        } catch (InvocationTargetException e) {
            if (e.getTargetException() instanceof CoreException) {
                ErrorDialog
                        .openError(
                                getContainer().getShell(), // Was Utilities.getFocusShell()
                                IDEWorkbenchMessages.WizardNewFolderCreationPage_errorTitle,
                                null, // no special message
                                ((CoreException) e.getTargetException())
                                        .getStatus());
            } else {
                // CoreExceptions are handled above, but unexpected runtime exceptions and errors may still occur.

                IDEWorkbenchPlugin.log(getClass(),
                        "createNewFolder()", e.getTargetException()); //$NON-NLS-1$
                MessageDialog
                        .openError(
                                getContainer().getShell(),
                                IDEWorkbenchMessages.WizardNewFolderCreationPage_internalErrorTitle, NLS.bind(IDEWorkbenchMessages.WizardNewFolder_internalError, e.getTargetException().getMessage()));
            }
            return; // ie.- one of the steps resulted in a core exception
        }
        
    }

}
