/*
 * Created on 26 sept. 2005
 *
 */
package net.sf.emis.ide.wizards;

import java.io.File;
import java.io.InputStream;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.SubProgressMonitor;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.internal.ui.JavaPlugin;
import org.eclipse.jdt.internal.ui.viewsupport.IViewPartInputProvider;
import org.eclipse.jdt.internal.ui.wizards.NewWizardMessages;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.actions.WorkspaceModifyOperation;
import org.eclipse.ui.dialogs.ContainerGenerator;
import org.eclipse.ui.internal.ide.IDEWorkbenchMessages;
import org.eclipse.ui.views.contentoutline.ContentOutline;


public class NewModulePrefsPage extends AbstractSetPrefsPage {

    public static String ID = "NewModuleSetPrefsPage";
    //private String moduleType = null;
    private Text fPackage;
    //private HashMap varMap = new HashMap();
    //private IResource selectedResource;
    private IJavaElement javaElement;
    
    public NewModulePrefsPage(String pageName) {
        super(ID, pageName, "Les paramtre FTP permettent le dploiement des ressources.");
     }

    public void init(IStructuredSelection selection) {
        
        /*Object firstSel = selection.getFirstElement();
        if (firstSel instanceof IResource) {
            selectedResource = (IResource)firstSel;
            System.out.println(selectedResource.getProjectRelativePath());
        }*/
        javaElement = getInitialJavaElement(selection);   
        
        //initContainerPage(jelem);
        String pName= ""; //$NON-NLS-1$
        if (javaElement != null) {
            IPackageFragment pf= (IPackageFragment) javaElement.getAncestor(IJavaElement.PACKAGE_FRAGMENT);
            if (pf != null && !pf.isDefaultPackage())
                pName= pf.getElementName();
        }
        varMap.put("ejb.package", pName);
        //fPackage.setText(pName);
        //updateStatus(new IStatus[] { fContainerStatus, fPackageStatus });

    }    
    
    public void createControl(Composite parent) {
        try{
        initializeDialogUnits(parent);
        // top level group
        Composite composite = new Composite(parent, SWT.NONE);
        composite.setFont(parent.getFont());
        composite.setLayout(new GridLayout());
        composite.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_FILL
                | GridData.HORIZONTAL_ALIGN_FILL));
        
        Group group = createGroup(composite, "Package", 2);
        fPackage = createTextField(group, "ejb.package", "Package : ");
        fPackage.setEditable(false);
        
        group = createGroup(composite, "Module", 2);
        Button button_filter = createRadio(group, "Filter");
        Button button_iRule = createRadio(group, "InputRule");
        Button button_oRule = createRadio(group, "OutputRule");
        Button button_eListener = createRadio(group, "EventReceiver");
        Button button_hook = createRadio(group, "Hook");
        varMap.put("ejb.type", "");
        
        group = createGroup(composite, "EJB", 2);
        createTextField(group, "ejb.name", "Module Name : ");
        createTextField(group, "ejb.description", "EJB Display Name : ");
        createTextField(group, "ejb.displayName", "EJB Description : ");
        
        setControl(composite);
        setPageComplete(false);
        } catch (Throwable th) {
            th.printStackTrace();
        }        
    }
    
    private Button createRadio(Composite parent, final String label) {
        Label emptyLabel = new Label(parent, SWT.NONE);
        emptyLabel.setText("              ");
        Button button = new Button(parent, SWT.RADIO);
        button.setText(label);
        button.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                varMap.put("ejb.type", label);
            }
        });
        return button;
    }
    
    public void createFileSet(final IFolder folder) { }
    
    public void createType() {
        
        IProgressMonitor monitor = new NullProgressMonitor();
        
        monitor.beginTask("Creating Module", 1);         
        
        try  {
            
            String ejbType = varMap.get("ejb.type").toString();
            String ejbName = varMap.get("ejb.name").toString();
            ejbName = ejbName.substring(0,1).toUpperCase() + ejbName.substring(1);
            varMap.put("ejb.name", ejbName);
            InputStream is = getResourceStream("templates/" + ejbType + "Bean.java");
            IFile typeHandle = createFileHandle(javaElement.getResource().getFullPath().append("." + ejbName + "Bean.java"));
            System.out.println(typeHandle.getLocation());
            createFile(typeHandle, is, new SubProgressMonitor(monitor, 1));
            replaceContent(typeHandle);
            
            javaElement.getResource().refreshLocal(IResource.DEPTH_ONE, null);
            
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } finally {
            monitor.done();
        }
        
    }

    /**
     * Utility method to inspect a selection to find a Java element. 
     * 
     * @param selection the selection to be inspected
     * @return a Java element to be used as the initial selection, or <code>null</code>,
     * if no Java element exists in the given selection
     */
    protected IJavaElement getInitialJavaElement(IStructuredSelection selection) {
        IJavaElement jelem= null;
        if (selection != null && !selection.isEmpty()) {
            Object selectedElement= selection.getFirstElement();
            if (selectedElement instanceof IAdaptable) {
                IAdaptable adaptable= (IAdaptable) selectedElement;         
                
                jelem= (IJavaElement) adaptable.getAdapter(IJavaElement.class);
                if (jelem == null) {
                    IResource resource= (IResource) adaptable.getAdapter(IResource.class);
                    if (resource != null && resource.getType() != IResource.ROOT) {
                        while (jelem == null && resource.getType() != IResource.PROJECT) {
                            resource= resource.getParent();
                            jelem= (IJavaElement) resource.getAdapter(IJavaElement.class);
                        }
                        if (jelem == null) {
                            jelem= JavaCore.create(resource); // java project
                        }
                    }
                }
            }
        }
        if (jelem == null) {
            IWorkbenchPart part= JavaPlugin.getActivePage().getActivePart();
            if (part instanceof ContentOutline) {
                part= JavaPlugin.getActivePage().getActiveEditor();
            }
            
            if (part instanceof IViewPartInputProvider) {
                Object elem= ((IViewPartInputProvider)part).getViewPartInput();
                if (elem instanceof IJavaElement) {
                    jelem= (IJavaElement) elem;
                }
            }
        }

        if (jelem == null || jelem.getElementType() == IJavaElement.JAVA_MODEL) {
            try {
                IJavaProject[] projects= JavaCore.create(getWorkspaceRoot()).getJavaProjects();
                if (projects.length == 1) {
                    jelem= projects[0];
                }
            } catch (JavaModelException e) {
                JavaPlugin.log(e);
            }
        }
        return jelem;
    }    
    
    /**
     * Returns the workspace root.
     * 
     * @return the workspace root
     */ 
    protected IWorkspaceRoot getWorkspaceRoot() {
        return ResourcesPlugin.getWorkspace().getRoot();
    }      
    
  

}
